; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_BEGRUESSUNG:
	; ZEILE1	
	rcall LCD_CLEAR


	ldi ZH, high(TEXT_BEGRUESSUNG_1*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_1*2)
	rcall ANZEIGE_TEXT

	; ZEILE2	
	rcall LCD_ZEILE2

	ldi ZH, high(TEXT_BEGRUESSUNG_2*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_2*2)
	rcall ANZEIGE_TEXT
	rcall wait_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ZEIT_DATUM:
	; ZEILE1	
	rcall LCD_CLEAR
	; DATUM		
	LDS temp1,(adr_TAG)
	rcall ANZEIGE_2_STELLEN_HEX_ASC_TEMP1
	LDS temp1,(adr_MONAT)
	rcall ANZEIGE_2_STELLEN_HEX_ASC_TEMP1
	LDS temp1,(adr_JAHR)
	rcall ANZEIGE_2_STELLEN_HEX_ASC_TEMP1
	rcall LCD_SPACE
	rcall LCD_SPACE
	; ZEIT		
	LDS temp1,(adr_hh)
	rcall ANZEIGE_2_STELLEN_HEX_ASC_TEMP1
	rcall LCD_DOPPEL_PUNKT
	LDS temp1,(adr_mm)
	rcall ANZEIGE_2_STELLEN_HEX_ASC_TEMP1
	rcall LCD_DOPPEL_PUNKT
	LDS temp1,(adr_ss)
	rcall ANZEIGE_2_STELLEN_HEX_ASC_TEMP1


	; ZEILE2	
	rcall LCD_ZEILE2
	; WOCHENTAG	
	rcall ANZEIGE_WOCHENTAG_KURZ
	ldi temp,'('
	rcall LCD_DATA
 	LDS temp1,(adr_WOCHENTAG)
	rcall ANZEIGE_1_STELLEN_HEX_ASC_TEMP1
	ldi temp,')'
	rcall LCD_DATA
	rcall LCD_SPACE
	rcall LCD_SPACE
	rcall LCD_SPACE
	rcall LCD_SPACE
	rcall LCD_SPACE
	; MESZ		
	ldi temp,'M'
	rcall LCD_DATA
	ldi temp,'E'
	rcall LCD_DATA
	ldi temp,'S'
	rcall LCD_DATA
	ldi temp,'Z'
	rcall LCD_DATA
	rcall LCD_DOPPEL_PUNKT
 	LDS temp1,(adr_MESZ)
	rcall ANZEIGE_1_STELLEN_HEX_ASC_TEMP1



ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_WOCHENTAG_KURZ:
 	LDS temp,(adr_WOCHENTAG)
	cpi temp,1
	breq ANZEIGE_WOCHENTAG_KURZ_1
	cpi temp,2
	breq ANZEIGE_WOCHENTAG_KURZ_2
	cpi temp,3
	breq ANZEIGE_WOCHENTAG_KURZ_3
	cpi temp,4
	breq ANZEIGE_WOCHENTAG_KURZ_4
	cpi temp,5
	breq ANZEIGE_WOCHENTAG_KURZ_5
	cpi temp,6
	breq ANZEIGE_WOCHENTAG_KURZ_6
	cpi temp,7
	breq ANZEIGE_WOCHENTAG_KURZ_7
	; ERROR
	ldi temp,'?'	
	rcall LCD_DATA
	ldi temp,'?'	
	rcall LCD_DATA
	ret
;-------------------------------------------------------------------------------
ANZEIGE_WOCHENTAG_KURZ_1:
	ldi temp,'M'	
	rcall LCD_DATA
	ldi temp,'o'	
	rcall LCD_DATA
	ret
;-------------------------------------------------------------------------------
ANZEIGE_WOCHENTAG_KURZ_2:
	ldi temp,'D'	
	rcall LCD_DATA
	ldi temp,'i'	
	rcall LCD_DATA
	ret
;-------------------------------------------------------------------------------
ANZEIGE_WOCHENTAG_KURZ_3:
	ldi temp,'M'	
	rcall LCD_DATA
	ldi temp,'i'	
	rcall LCD_DATA
	ret
;-------------------------------------------------------------------------------
ANZEIGE_WOCHENTAG_KURZ_4:
	ldi temp,'D'	
	rcall LCD_DATA
	ldi temp,'o'	
	rcall LCD_DATA
	ret
;-------------------------------------------------------------------------------
ANZEIGE_WOCHENTAG_KURZ_5:
	ldi temp,'F'	
	rcall LCD_DATA
	ldi temp,'r'	
	rcall LCD_DATA
	ret
;-------------------------------------------------------------------------------
ANZEIGE_WOCHENTAG_KURZ_6:
	ldi temp,'S'	
	rcall LCD_DATA
	ldi temp,'a'	
	rcall LCD_DATA
	ret
;-------------------------------------------------------------------------------
ANZEIGE_WOCHENTAG_KURZ_7:
	ldi temp,'S'	
	rcall LCD_DATA
	ldi temp,'o'	
	rcall LCD_DATA
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ERROR:
	tst FEHLER_CODE
	brne ANZEIGE_ERROR_RUN
	cbi PORTD,LED_D_GRUEN	; GRN	
	ret
ANZEIGE_ERROR_RUN:
	sbi PORTD,LED_D_GRUEN	; GRN	
	rcall wait_1s
	; ZEILE1	
	rcall LCD_CLEAR
	ldi temp,'E'	
	rcall LCD_DATA
	ldi temp,'R'	
	rcall LCD_DATA
	ldi temp,'R'	
	rcall LCD_DATA
	ldi temp,'O'	
	rcall LCD_DATA
	ldi temp,'R'	
	rcall LCD_DATA

	; ZEILE2	
	rcall LCD_ZEILE2
	; CODE		
	mov temp1,FEHLER_CODE
	rcall ANZEIGE_3_STELLEN_HEX_ASC_TEMP1
	rcall wait_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1																	
ANZEIGE_1_STELLEN_HEX_ASC_TEMP1:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_1_STELLEN_KURZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1																	
ANZEIGE_2_STELLEN_HEX_ASC_TEMP1:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_2_STELLEN_KURZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1																	
ANZEIGE_3_STELLEN_HEX_ASC_TEMP1:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP8													  
LCD_AUSGABE_ZAHL_9_STELLEN_KURZ:
	mov temp, temp9			; 9.ZEICHEN 
	rcall LCD_DATA	
LCD_AUSGABE_ZAHL_8_STELLEN_KURZ:
	mov temp, temp8			; 8.ZEICHEN 
	rcall LCD_DATA	
LCD_AUSGABE_ZAHL_7_STELLEN_KURZ:
	mov temp, temp7			; 7.ZEICHEN 
	rcall LCD_DATA	
LCD_AUSGABE_ZAHL_6_STELLEN_KURZ:
	mov temp, temp6			; 6.ZEICHEN 
	rcall LCD_DATA	
LCD_AUSGABE_ZAHL_5_STELLEN_KURZ:
	mov temp, temp5			; 5.ZEICHEN 
	rcall LCD_DATA	
LCD_AUSGABE_ZAHL_4_STELLEN_KURZ:
	mov temp, temp4			; 4.ZEICHEN 
	rcall LCD_DATA	
LCD_AUSGABE_ZAHL_3_STELLEN_KURZ:
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA	
LCD_AUSGABE_ZAHL_2_STELLEN_KURZ:
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
LCD_AUSGABE_ZAHL_1_STELLEN_KURZ:
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;																			
;	Value: 0...	99.999.999													
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		   1-er Stelle)									
;			temp2	(		  10-er Stelle)									
;			temp3	(        100-er Stelle)									
;			temp4	(      1.000-er Stelle)									
;			temp5	(     10.000-er Stelle)									
;			temp6	(    100.000-er Stelle)									
;			temp7	(  1.000.000-er Stelle)									
;			temp8	( 10.000.000-er Stelle)									
; 																			
; rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8			
; 																			
FUNKTION_HEX_ASC_32:
	clr temp
FUNKTION_HEX_ASC_10000000:; 10.000.000
	inc temp
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_10000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp8) auf dem Stack sichern            
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
	clr temp
FUNKTION_HEX_ASC_1000000:
	inc temp
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_1000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp7) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
	clr temp
FUNKTION_HEX_ASC_100000:
	inc temp
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_100000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp6) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
	clr temp
FUNKTION_HEX_ASC_10000:
	inc temp
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_10000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp5) auf dem Stack sichern            
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
	clr temp
FUNKTION_HEX_ASC_1000:
	inc temp
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_1000
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp4) auf dem Stack sichern            
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
	clr temp
FUNKTION_HEX_ASC_100:
	inc temp
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_100
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp3) auf dem Stack sichern            
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
	clr temp
FUNKTION_HEX_ASC_10:
	inc temp
	subi temp1, low  (10)
	sbci temp2, HIGH (10)
	brcc FUNKTION_HEX_ASC_10
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp2) auf dem Stack sichern            
	subi temp1, low  (-10)
	sbci temp2, HIGH (-10)
FUNKTION_HEX_ASC_1:	
	subi temp1, -48		; HEX->ASC

	pop	TEMP2			; LESEN vom STACK (KOPIE)
	pop	TEMP3			; LESEN vom STACK (KOPIE)
	pop	TEMP4			; LESEN vom STACK (KOPIE)
	pop	TEMP5			; LESEN vom STACK (KOPIE)
	pop	TEMP6			; LESEN vom STACK (KOPIE)
	pop	TEMP7			; LESEN vom STACK (KOPIE)
	pop	TEMP8			; LESEN vom STACK (KOPIE)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; LCD-INITIALISIERUNG															
LCD_INITIALISIERUNG:
 
 	ldi temp, 0b00000011        ;muss 3mal hintereinander gesendet werden zur Initialisierung
	rcall LCD_COMMAND
	rcall wait_5ms
	rcall LCD_COMMAND
	rcall wait_5ms
	rcall LCD_COMMAND
	rcall wait_5ms

    ldi temp, 0b00000010        ;4bit-Modus einstellen
	rcall LCD_COMMAND
	rcall wait_5ms

    ldi temp, 0b00000001        ; DISPLAY lschen			
 	rcall LCD_COMMAND
	rcall wait_5ms
    ldi temp, 0b00001111        ; DISPLAY ein / CURSOR blinken
	rcall LCD_COMMAND
	rcall wait_5ms
    ldi temp, 0b00000110        ; Cursor Auto-Increment
 	rcall LCD_COMMAND
	rcall wait_5ms


ret
;######################################################################## 
;######################################################################## 
;																		  
;erzeugt den Enable-Puls												  
;																		  
LCD_ENABLE:
	sbi LCD_E_PORT, LCD_E       ; Enable high		
 	rcall wait_50us              ; kurze PAUSE		
	cbi LCD_E_PORT, LCD_E       ; Enable low		
	rcall wait_50us              ; kurze PAUSE		
ret                          
;######################################################################## 
;######################################################################## 
;######################################################################## 
; sendet ein Datenbyte an das LCD										  
;																		  
; INPUT: temp															  
;																		  
; rcall LCD_DATA			; DATENBYTE an LCD inp: temp 				  
;																		  
LCD_DATA:
	push temp             	; "Sicherungskopie" 			
	push temp             	; "Sicherungskopie" 			
    swap temp               ; Vertauschen					
   	andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						
    
	sbi LCD_RS_PORT, LCD_RS ; RS ein (high)					
	rcall lcd_enable        ; Enable-Routine aufrufen		
                         
    pop temp				; Kopie wieder laden	 		
   	andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						
   
    sbi LCD_RS_PORT, LCD_RS ; RS ein  (high)	     		
	rcall lcd_enable        ; Enable-Routine aufrufen		
    pop temp				; Kopie wieder laden	 		
ret				                       
;######################################################################## 
;######################################################################## 
;######################################################################## 
;sendet einen Befehl an das LCD;wie lcd_data, nur ohne RS zu setzen		  
;																		  
; INPUT: temp															  
;																		  
LCD_COMMAND:                            
    push temp				; "Sicherungskopie" 			
    push temp				; "Sicherungskopie" 			
    swap temp				; Vertauschen					
    andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						

    cbi LCD_RS_PORT, LCD_RS ; RS aus (low)					
	rcall lcd_enable		; Enable-Routine aufrufen		
           
	pop temp				; Kopie wieder laden			
  	andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						
           
	cbi LCD_RS_PORT, LCD_RS ; RS aus (low)       			
	rcall lcd_enable		; Enable-Routine aufrufen		
	rcall wait_5ms			; Pause (wichtig)				
    pop temp				; Kopie wieder laden	 
 
ret
;######################################################################## 
;########################################################################
;######################################################################## 
ANZEIGE_TEXT:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	breq ANZEIGE_TEXT_e 	; Sprung
	rcall LCD_DATA			; Anzeige
	rjmp ANZEIGE_TEXT
	ANZEIGE_TEXT_e:
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; Display lschen														  
LCD_CLEAR:
   	ldi temp, 0b00000001
    rcall lcd_command
ret
;######################################################################## 
; KURSOR GO-HOME														  
LCD_GO_HOME:
 	ldi temp, 0b00000010
	rcall lcd_command 
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; KURSOR Sprung in ZEILE2
LCD_ZEILE2:
 			ldi temp, 0b11000000 
			rcall lcd_command 
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_SPACE:
	ldi temp, ' '		; SPACE
	rcall LCD_DATA	
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_PUNKT:
	ldi temp, '.'		; PUNKT
	rcall LCD_DATA	
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_3_PUNKT:
	ldi temp, '.'		; PUNKT
	rcall LCD_DATA	
	rcall LCD_DATA	
	rcall LCD_DATA	
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_DOPPEL_PUNKT:
	ldi temp, ':'		; DOPPELPUNKT
	rcall LCD_DATA	
ret

